#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/16 22:46:56 +0900>
#
# X^[̃eXg
# p[^ςēmF

require 'dxruby'
require_relative 'floorraster'

# 摜ǂݍ
imgfilename = "cloud.png"
if File.file?(imgfilename)
  image = Image.load(imgfilename)
else
  # 摜t@CȂ΁A^C摜쐬
  image = FloorRaster.get_grid_image(160, 160)
end

bg = FloorRaster.new(image) # p
bg2 = FloorRaster.new(image) # Vp

bg.set_fog(2, [1.0, 1.0, 1.0, 1.0])
bg2.set_fog(2, [1.0, 1.0, 1.0, 1.0])

x = 0
z = 0
x_spd = 8
z_spd = 5
floor_dist = 0.3
scr_dist = 0.3
y_diff = 0.1

font = Font.new(16)
fade_enable = false
count = 0
center_x = Window.width / 2
center_y = Window.height / 2

Window.loop do
  break if Input.keyPush?(K_ESCAPE)

  # xZbg
  if Input.keyDown?(K_C)
    x_spd = 0
    z_spd = 0
  end

  # XN[xύX
  x_spd += 0.1 * Input.x

  # sXN[xύX
  z_spd -= 0.1 * Input.y

  # Ƃ̋ύX
  floor_dist += 0.01 if Input.keyDown?(K_W)
  floor_dist -= 0.01 if Input.keyDown?(K_S)

  # ʂ܂ł̋ύX
  scr_dist += 0.005 if Input.keyDown?(K_D)
  scr_dist -= 0.005 if Input.keyDown?(K_A)
  scr_dist = 0.05 if scr_dist < 0.05

  # ㉺ɂ炷lύX
  y_diff += 0.005 if Input.keyDown?(K_R)
  y_diff -= 0.005 if Input.keyDown?(K_F)

  # xύX
  fade_enable = !fade_enable if Input.keyPush?(K_Q)
  alpha = (fade_enable)? Math.sin(3 * count * Math::PI / 180.0).abs : 1.0

  # XN[ʒuύX
  x += x_spd
  z += z_spd

  # `
  bg.draw(center_x, center_y, x, z, :vflip=>false,
          :floor_dist=>floor_dist, :scr_dist=>scr_dist, :y_diff=>y_diff,
          :z=>-255, :alpha=>alpha)

  bg2.draw(center_x, center_y, x, -z, :vflip=>true,
           :floor_dist=>floor_dist, :scr_dist=>scr_dist, :y_diff=>y_diff,
           :z=>-255, :alpha=>alpha)

  # `
  tx = 4
  h = 20
  Window.drawFont(tx, h * 0, "RIGHT , LEFT : x speed = #{x_spd}", font)
  Window.drawFont(tx, h * 1, "UP , DOWN    : z speed = #{z_spd}", font)
  Window.drawFont(tx, h * 2, "W , S : floor dist = #{floor_dist}", font)
  Window.drawFont(tx, h * 3, "D , A : screen dist = #{scr_dist}", font)
  Window.drawFont(tx, h * 4, "R , F : y_diff = #{y_diff}", font)
  Window.drawFont(tx, h * 5, "Q : Fade in/out", font)
  Window.drawFont(tx, h * 6, "C : Speed clear", font)

  count += 1
end
